#ifndef __GL_HPP__
#define __GL_HPP__

#include "glutil.hpp"

namespace DECS{
  namespace GL{

    static GLColor DGL_WHITE(1.0, 1.0, 1.0, 1.0);
    static GLColor DGL_BLACK(0.0, 0.0, 0.0, 1.0);
    static GLColor DGL_RED(1.0, 0.0, 0.0, 1.0);
    static GLColor DGL_GREEN(0.0, 1.0, 0.0, 1.0);
    static GLColor DGL_BLUE(0.0, 0.0, 1.0, 1.0);

    static GLPosition DGL_ORIGIN(0.0, 0.0, 0.0);

    class GLObject{
    protected:
      int mode_;
      GLColor color_;
    public:
      GLObject():mode_(GL_POLYGON){};
      GLObject(int mode):mode_(mode){};
      GLObject(int mode, GLColor color):mode_(mode), color_(color){};
      virtual void setColor(GLColor color) = 0;
      virtual void draw() = 0;
    };
  }
}

#endif // __GL_HPP__
