#ifndef __GLWINDOW_HPP__
#define __GLWINDOW_HPP__

#include <string>

#include "gl.hpp"

using namespace std;

namespace DECS{
  namespace GL{

    struct GLWindowProperty{
      string title_;
      unsigned int mode_;
      GLColor bgColor_;

      int wWidth_;
      int wHeight_;
      int wPositionX_;
      int wPositionY_;
    };

    static GLWindowProperty DEFAULT_WPROP = {
      "GLWindow", GL_RGBA, DGL_WHITE,
      300, 300, 100, 100};

    class GLWindow{
    private:
      GLWindowProperty* wProp_;
      
      void (*displayFunc_)();

      void init();
    public:
      GLWindow(int argc, char* argv[]):
	wProp_(&DEFAULT_WPROP)
      {
	this->wProp_->wPositionX_ =
	  (glutGet(GLUT_SCREEN_WIDTH) - this->wProp_->wWidth_) / 2;
	this->wProp_->wPositionY_ =
	  (glutGet(GLUT_SCREEN_HEIGHT) - this->wProp_->wHeight_) / 2;
	glutInitWindowPosition(this->wProp_->wPositionX_,
			       this->wProp_->wPositionY_);
	glutInitWindowSize(this->wProp_->wWidth_, this->wProp_->wHeight_);
	glutInit(&argc, argv);
	glutInitDisplayMode(this->wProp_->mode_);
      }

      GLWindow(int argc, char* argv[], GLWindowProperty* wProp):
	wProp_(wProp)
      {
	glutInitWindowPosition(this->wProp_->wPositionX_,
			       this->wProp_->wPositionY_);
	glutInitWindowSize(this->wProp_->wWidth_, this->wProp_->wHeight_);
	glutInit(&argc, argv);
	glutInitDisplayMode(this->wProp_->mode_);
      }
      
      ~GLWindow(){};
      
      void setBGColor(GLColor bgColor);
      void setDisplayFunc(void (*displayFunc)());

      void create();
    };
  }
}

#endif // __GLWINDOW_HPP__
