#include <cstdlib>

#include "gl.hpp"
#include "glwindow.hpp"
#include "glbasicshape.hpp"

using namespace std;
using namespace DECS::GL;

void display(){
  GLPosition center(0.3, 0.3, 0.0);
  GLdouble r = 0.35;
  GLColor cColor(1.0, 1.0, 0.0);
  GLCircle circle(GL_POLYGON, center, r, cColor);

  GLPosition tPoint1(-0.9, -0.9, 0.0);
  GLPosition tPoint2(0.5, -0.4, 0.0);
  GLPosition tPoint3(-0.9, 0.0, 0.0);
  GLColor tColor(1.0, 0.0, 1.0);
  GLTriangle tri(GL_POLYGON, tPoint1, tPoint2, tPoint3, tColor);

  GLPosition sPoint1(-0.9, 0.9, 0.0);
  GLPosition sPoint2(-0.5, 0.9, 0.0);
  GLPosition sPoint3(-0.2, 0.4, 0.0);
  GLPosition sPoint4(-0.9, 0.5, 0.0);
  GLColor sColor(0.0, 1.0, 1.0);
  GLSquare square(GL_POLYGON, sPoint1, sPoint2, sPoint3, sPoint4);

  GLPosition begin(0.9, -0.9, 0.0);
  GLPosition end(-0.9, -0.6, 0.0);
  GLColor lColor(0.5, 0.5, 0.5);
  GLLine line(begin, end, lColor);

  glClear(GL_COLOR_BUFFER_BIT);
  circle.draw();
  tri.draw();
  square.draw();
  line.draw();
  glFlush();
}

int main(int argc, char* argv[]){
  GLWindowProperty wProp = {
      "DECS GL TEST", GL_RGBA, DGL_WHITE,
      500, 500, 100, 100};

  GLWindow w(argc, argv, &wProp);
  w.setDisplayFunc(display);
  w.create();

  return EXIT_SUCCESS;
}
